import setuptools

def get_data(field, data):
    datum = None
    try:
        datum = data[field]
    except KeyError as e:
        pass
    return datum

data = {}
# a replacement for setuptools.setup
def my_setup(*args, **kwargs):
    fields = [
        'name',
        'version',
        'description',
        'license',
        'install_requires',
        'tests_require',
        'entry_points'
    ]

    for field in fields:
        data[field] = get_data(field, kwargs)

def main():
    # monkey-patch over the setuptools setup() function to do our function instead
    setuptools.setup = my_setup
    # load the setup.py file
    import setup
    # instead of exiting, we now have populated our global variable, without doing any parsing
    for field, datum in data.items():
        print('{}: {}'.format(field, datum))

if __name__ == "__main__":
    main()